%define _enable_debug_packages %{nil}
%define debug_package          %{nil}

%define	release	%mkrel 2

%define	name	plib
%define	version	1.8.5

%define lib_major	1
%define lib_name	%mklibname %{name} %{lib_major}
%define	lib_name_devel	%mklibname %{name} %{lib_major} -d

Summary:	Steve's Portable Game Library
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	LGPL
Group:		Development/C++
Source0:	http://plib.sourceforge.net/dist/%{name}-%{version}.tar.xz
Patch0:         plib-1.8.4-extraqualif.patch
Patch1:         plib-1.8.4-fullscreen.patch
Patch2:         plib-1.8.4-js.patch
Patch3:         plib-1.8.4-autorepeat.patch
URL:		http://plib.sourceforge.net/
Buildrequires:	MesaGLU-devel Mesa-common-devel
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Write games and other realtime interactive applications that are 100% portable
across a wide range of hardware and operating systems.

%package -n %{lib_name}
Summary: Set of portable libraries especially useful for games
Group: System/Libraries
Obsoletes:	%{name} < %{version}-%{release}
Provides: 	%{name} = %{version}-%{release}

%description -n %{lib_name}
This is a set of OpenSource (LGPL) libraries that will permit programmers
to write games and other realtime interactive applications that are 100%
portable across a wide range of hardware and operating systems. Here is
what you need - it's all free and available with LGPL'ed source code on
the web. All of it works well together.

%package -n %{lib_name_devel}
Summary:	Headers for developing programs that will use %{name}
Group: 		Development/Libraries
Provides: 	%{name}-devel = %{version}-%{release}
Provides: 	lib%{name}-devel = %{version}-%{release}
Requires: 	%{lib_name} = %{version}

%description -n %{lib_name_devel}
This package contains the headers that programmers will need to develop
applications which will use %{name}.

%prep
%setup -q
#%patch0 -p1 -b .extraqualif
%patch1 -p1 -b .fs
#%patch2 -p1 -b .js
%patch3 -p1 -b .autorepeat
# for some reason this file has its x permission sets, which makes rpmlint cry
chmod -x src/sg/sgdIsect.cxx

%build
export CFLAGS="$RPM_OPT_FLAGS -fPIC -DXF86VIDMODE"
export LDFLAGS="$RPM_OPT_FLAGS -fPIC -DXF86VIDMODE"
export CXXFLAGS="$RPM_OPT_FLAGS -fPIC -DXF86VIDMODE"
%configure2_5x
%make
# and below is a somewhat dirty hack inspired by debian to build shared libs
# instead of static. Notice that the adding of -fPIC to CXXFLAGS above is part
# of the hack.
dirnames=(util sg ssg fnt js net psl pui puAux pw sl sl ssgAux)
libnames=(ul sg ssg fnt js net psl pu puaux pw sl sm ssgaux)
libdeps=("" \
  "-L../util -lplibul" \
  "-L../util -lplibul -L../sg -lplibsg -lGL" \
  "-L../util -lplibul -L../sg -lplibsg -lGL" \
  "-L../util -lplibul" \
  "-L../util -lplibul" \
  "-L../util -lplibul" \
  "-L../util -lplibul -L../sg -lplibsg -L../fnt -lplibfnt -lGL" \
  "-L../util -lplibul -L../sg -lplibsg -L../fnt -lplibfnt -L../pui -lplibpu -lGL" \
  "-L../util -lplibul -lX11 -lGL -lXxf86vm" \
  "-L../util -lplibul" \
  "-L../util -lplibul" \
  "-L../util -lplibul -L../sg -lplibsg -L../ssg -lplibssg -lGL")

for (( i = 0; i < 13; i++ )) ; do
  pushd src/${dirnames[$i]}
  gcc -shared -Wl,-soname,libplib${libnames[$i]}.so.%{version} \
    -o libplib${libnames[$i]}.so.%{version} `ar t libplib${libnames[$i]}.a` \
    ${libdeps[$i]}
  ln -s libplib${libnames[$i]}.so.%{version} libplib${libnames[$i]}.so
  popd
done

%install
rm -rf $RPM_BUILD_ROOT
%{makeinstall} includedir=$RPM_BUILD_ROOT%{_includedir}/%{name}
# we don't want the static libs
rm $RPM_BUILD_ROOT%{_libdir}/*.a
# instead do a DIY install of the shared libs we created
cp -a `find . -name "libplib*.so*"` $RPM_BUILD_ROOT%{_libdir}

%clean
rm -rf $RPM_BUILD_ROOT

%post -n %{lib_name}
/sbin/ldconfig

%postun -n %{lib_name}
/sbin/ldconfig

%files -n %{lib_name}
%defattr(-,root,root,0755)
%doc README ChangeLog AUTHORS KNOWN_BUGS
%{_libdir}/libplib*.so.%{version}
%{_includedir}/plib

%files -n %{lib_name_devel}
%defattr(-,root,root,-)
%{_includedir}/*
%{_libdir}/libplib*.so

%changelog
* Mon Oct 17 2011 Texstar <texstar at gmail.com> 1.8.5-2pclos2011
- fix rpm group Development/Libraries

* Sat Jun 14 2009 MBantz <martin dot bantz at gmail dot com> 1.8.5-1pclos2007
- Update to 1.8.5

* Sat Dec 09 2006 Torbjorn Turpeinen <tobbe@nyvalls.se> 1.3-1
- initial build for pclinuxos 2007
